.data

# colors
red: .word 0x00ff0000
green: .word 0x0000ff00

# variable globale
unitWidth: .word 1
unitHeight: .word 1
dsplWidth: .word 4
dsplHeight: .word 1

initial: .word 0 # variable qui contient l'adresse du premier pixel de l'image, 

.text
# -<<---------------------------------------------
# -<<-CHOIX-D-IMPLEMENTATION----------------------
# Nous avons decidé que la tête du serpent sera le dernier element du tableau (serpent)
# 
# Puis pour ce qui est de l'ajout et supppression d'un element au tableau (serpent),
# on decidé d'implemeenter une file ciculaire pour eviter le decalement et ainsi obtenir un algorithme de complexité o(1)
# ->>---------------------------------------------
# ->>---------------------------------------------

# ->>---------------------------------------------
# MAIN
_main_:
	jal _F_creer_
	move $s0, $v0				# la file est dans $s0

	# teste manuel avec exemple concret :
	move $a0, $s0
	li $a1, 9
	jal _F_enfiler_

	li $a1, 8
	jal _F_enfiler_

	li $a1, 7
	jal _F_enfiler_
	
	li $a1, 6
	jal _F_enfiler_

	jal _F_defiler_

	li $a1, 10
	jal _F_enfiler_
	
	jal _F_defiler_
	
	li $a1, 11
	jal _F_enfiler_
	
	jal _F_defiler_
	
	li $a1, 12
	jal _F_enfiler_
	
	jal _F_defiler_
	
	li $a1, 13
	jal _F_enfiler_

	li $a1, 4
	jal _F_valeurIndice_
	move $s0, $v0

	li $a1, 9
	jal _F_contient_
	move $s0, $v0

	jal _F_lister_

	j _exit_
# -<<---------------------------------------------

# -<<---------------------------------------------
# ->>---------------------------------------------


# ->>---------------------------------------------
_I_largeur_:
# 	Donne la largeur en unité de pixel
# ARGS: VOID
# RETU:	$v0<largeur de l'image>
# PREC: NONE
# prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
# corps
	lw $t0, dsplWidth			# variable resolution en LARGEUR de l'image 
	lw $t1, unitWidth			# variable unité de representation des pixels en LARGEUR de l'image
	div $v0, $t0, $t1
# epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4
	
	jr $ra
# -<<---------------------------------------------


# ->>---------------------------------------------
_I_hauteur_:
# 	Donne la hauteur en unité de pixel
# ARGS: VOID
# RETU:	$v0<hauteur de l'image>
# PREC: NONE
# prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
# corps
	lw $t0, dsplHeight			# variable resolution en HAUTEUR de l'image
	lw $t1, unitHeight			# variable unité de representation des pixels en HAUTEUR de l'image
	div $v0, $t0, $t1
# epilgue
	lw $ra, ($sp)
	add $sp, $sp, 4
	
	jr $ra
# -<<---------------------------------------------



# -<<---------------------------------------------
_F_creer_:
# 	Alloue un espace memoire pour le corps du serpent
# ARGS: VOID
# RETU: $v0<adresse de la file>
# PREC: NONE
# prologue
	sub $sp, $sp, 8
	sw $ra, ($sp)
	sw $s0, 4($sp)
# corps

	# creation de la file
	li $t0, 12				# une file de 3 elements * 4 octets (adresse de l'element le plus ancient, taille, adresse de la premier case memoire du tableau)
	move $a0, $t0				# passage en argument de $t0
	li $v0, 9				# sbrk (allocation memoire)
	syscall					# appel systeme
	move $s0, $v0				# sauvegarde de l'adresse de file

	# creation du serpent
	jal _I_largeur_				# calcule de la largeur
	move $t9, $v0				# recuperation de la valeur de largeur
	jal _I_hauteur_				# calcule de la hauteur
	move $t8, $v0				# recuperation de la valeur de hauteur
	mul $t0, $t9, $t8			# nombre de pixel de l'image
	mul $t0, $t0, 4				# convertion en octets
	move $a0, $t0				# passage en argument de la taille

	li $v0, 9				# sbrk (allocation memoire)
	syscall					# adresse du tableau dans $v0

	sw $v0, ($s0)				# stockage de l'adresse du serpent dans le premier element de la file
	sw $v0, 8($s0)				# stockage de l'adresse de la premier case du tableau (pour une file circulaire)
	move $v0, $s0				# retour de l'adresse de la file

# epilogue
	lw $ra, ($sp)
	lw $s0, 4($sp)
	add $sp, $sp, 8

	jr $ra
# ->>---------------------------------------------


# -<<---------------------------------------------
_F_enfiler_:
# 	Rajoute un nouvel element $a1 au tableau $a0
# ARGS: $a0<adresse de la file>, $a1<nouveau pixel>
# RETU: VOID
# PREC: $a1, nouveau pixel doit appartenir au plage memoire de l'image
# prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
# corps
	lw $t0, ($a0)				# recuperation de l'adresse du premier element de la file, qui est le tableau (serpent)

	# calcul du decalage par rapport au plus ancien element, pour arriver au dernier element rajouté au tableau
	lw $t1, 4($a0)				# recuperation de la taille de la file (composée que de deux elements)
	mul $t1, $t1, 4				# convertion en octet de la taille
	add $t0, $t0, $t1			# ajout du decalage a l'adresse du premier element du tableau pour acceder a l'adresse de la premier case vide du tableau du serpent
	
	# ------------
	# si il y a depassement du tableau alloue, on revient a debut de la file (file circulaire)
	# $a0 est le meme argument pour cette fonction
	move $s1, $a1				# sauvegarde de valeur de $a1
	move $a1, $t0
	jal _check_overflow_		# recalcul la valeur de l'adresse de stockage pour qu'il n'y ait pas de depassement (avec une file circulaire)
	# sinon on garde la valeur initiale de l'adresse
	move $t0, $v0				# recuperarion de la valeur de retour
	move $a1, $s1				# reaffectation de valeur de $a1
	# ------------

	sw $a1, ($t0)				# stockage de du nouveau pixel

	# incrementation de la taille
	lw $t0, 4($a0)				# recuperation de taille
	add $t0, $t0, 1				# incrementation
	sw $t0, 4($a0)				# stockage de la nouvelle taille

# epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4

	jr $ra
# ->>---------------------------------------------


# -<<---------------------------------------------
_F_defiler_:
# 	Rajoute un nouvel element $a1 au tableau $a0
# ARGS: $a0<adresse de la file>
# RETU: VOID
# PREC: la file ne doit pas être vide
# prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
# corps

	# changement du premier element
	lw $t0, ($a0)				# recuperation de l'adresse du premier element de la file, qui est le tableau (serpent)
	add $t0, $t0, 4				# la case memoire suivante devient le premier element du tableau
	# ------------
	# si il y a depassement du tableau alloue, on revient a debut de la file (file circulaire)
	# $a0 est le meme argument pour cette fonction
	move $a1, $t0
	jal _check_overflow_		# recalcul la valeur de l'adresse de stockage pour qu'il n'y ait pas de depassement (avec une file circulaire)
	# sinon on garde la valeur initiale de l'adresse
	move $t0, $v0				# recuperarion de la valeur de retour
	# ------------
	sw $t0, ($a0)				# affectation du nouveau premier element du tableau

	# decrementation de la taille
	lw $t0, 4($a0)				# recuperation de taille
	sub $t0, $t0, 1				# decrementation
	sw $t0, 4($a0)				# stockage de la nouvelle taille

# epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4

	jr $ra
# ->>---------------------------------------------


# ->>---------------------------------------------
_check_overflow_:
# 	Verfie si une adresse deborde d'un tableau, si oui, retourne l'adresse modulo taille sinon, sa valeur initiale
# ARGS: $a0<adresse de la file>, $a1<adresse a verifier>
# RETU: $v0<nouvelle adresse>
# PREC: $a1 inferieur a l'adresse de la premier case memoire fois deux
# prologue
	sub $sp, $sp, 8
	sw $ra, ($sp)
	sw $s0, 4($sp)
# corps

	# calcul de la taille de l'image qui est la taille maximum du serpent
	jal _I_largeur_				# calcule de la largeur
	move $t9, $v0				# recuperation de la valeur de largeur
	jal _I_hauteur_				# calcule de la hauteur
	move $t8, $v0				# recuperation de la valeur de hauteur
	mul $t0, $t8, $t9			# taille maximum du serpent
	mul $t0, $t0, 4				# convertion en octet

	# calcul de l'adresse de la derniere case memoire possible du serpent
	lw $t1, 8($a0)				# recuperation de l'adresse de la premier case memoire du serpent
	add $t0, $t1, $t0			# obtention de l'adresse + 4 octets de la derniere case memoire possible du serpent
	
	# condition :
	blt $a1, $t0, nothingToDo 	# si l'argument est inferieur stricte a l'adresse de la derniere case memoire
	# sinon
	sub $t1, $a1, $t0			# calcul du decalage a faire pour obtenir un element
	lw $t2, 8($a0)				# recuperation de l'adresse de la premier case memoire du serpent
	add $t1, $t1, $t2			# on obtient l'adresse de la nouvelle case memoire en fonction de la file circulaire
	move $v0, $t1				# retourne la valeur de l'adresse
	j next						# ne pas reaffecter l'ancienne valeur de l'argument au registre de retour
nothingToDo: # renvoie la valeur initiale de l'argument
	move $v0, $a1
next:

# epilogue
	lw $ra, ($sp)
	lw $s0, 4($sp)
	add $sp, $sp, 8

	jr $ra
# -<<---------------------------------------------


# -<<---------------------------------------------
_F_valeurIndice_:
# 	Retourne la valeur de element de la file a l'indice donne
# ARGS: $a0<adresse de la file>, $a1<indice>
# RETU: $v0<valeur>
# PREC: indice doit etre compris entre 0 et taille de file moins 1
# prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
# corps

	lw $t0, ($a0)				# recuperation de l'adresse de l'element le plus ancien (queue du serpent)
	mul $t1, $a1, 4				# passage en octet de l'indice
	add $t0, $t0, $t1			# deplacement de indice * 4 octets de case memoire
	# ------------
	# si il y a depassement du tableau alloue, on revient a debut de la file (file circulaire)
	# $a0 est le meme argument pour cette fonction
	move $a1, $t0
	jal _check_overflow_			# recalcul la valeur de l'adresse de stockage pour qu'il n'y ait pas de depassement (avec une file circulaire)
	# sinon on garde la valeur initiale de l'adresse
	move $t0, $v0				# recuperarion de la valeur de retour
	# ------------
	lw $v0, ($t0)				# recuperation de valeur dans la file

# epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4

	jr $ra
# ->>---------------------------------------------



# -<<---------------------------------------------
_F_contient_:
# 	Retourne une valeure boolean si un pixel appartient ou non a une file
# ARGS: $a0<adresse de la file>, $a1<pixel>
# RETU: $v0<valeur boolean>
# PREC: NONE
# prologue
	sub $sp, $sp, 12
	sw $ra, ($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
# corps

	lw $s1, 4($a0)					# recuperation de la taille de la file
loop:
	sub $s1, $s1, 1					# indice de la queue du serpent
	move $s2, $a1					# sauvegarde de la valeur de $a1
	move $a1, $s1					# passage en argument l'indice
	jal _F_valeurIndice_				# recuperation de l'element a l'indice `indice`
	move $a1, $s2					# reaffectation de la valeur initiale de $a1
	beq $v0, $a1, yes				# si pixel egal a l'element de la file a l'indice `indice`, retourne 1
	beqz $s1, no					# si on arrive a la fin du tableau (tete du serpent), retourne 0
	j loop						# sinon on continue la boucle
yes:
	li $v0, 1
	j break
no:
	li $v0, 0
break:

# epilogue
	lw $ra, ($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	add $sp, $sp, 12

	jr $ra
# ->>---------------------------------------------




# -<<---------------------------------------------
_F_lister_:
# 	Affiche en sortie standard les elements de la file passee en parametres
# ARGS: $a0<adresse de la file>
# RETU: VOID
# PREC: NONE
# prologue
	sub $sp, $sp, 12
	sw $ra, ($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
# corps

	lw $s1, 4($a0)					# recuperation de la taille de la file
while:
	sub $s1, $s1, 1					# indice de la queue du serpent
	move $a1, $s1					# passage en argument l'indice
	jal _F_valeurIndice_				# recuperation de l'element a l'indice `indice`
	
	move $s2, $a0					# sauvegarde de l'argument $a0
	move $a0, $v0					# passage en argument la valeur a affichee
	li $v0, 1
	syscall
	move $a0, $s2					# reaffectation de la valeur de $a0
	
	beqz $s1, end					# si on arrive a la fin du tableau (tete du serpent), fin d'affichage
	j while						# sinon on continue la boucle
end:

# epilogue
	lw $ra, ($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	add $sp, $sp, 12

	jr $ra
# ->>---------------------------------------------



# ->>---------------------------------------------
# arret complet du programme
_stop_:
	j _exit_
# -<<---------------------------------------------


# ->>---------------------------------------------
# Sortie du programme
_exit_:
	li $v0, 10
	syscall
# -<<---------------------------------------------
